/*
 *	Summarize JR-Comm usage from jrcomm.log file.
 */

if ~open('jrclog','JRComm:JRComm.log','Read') then
	do
	say 'Couldn''t open jrcomm.log'
	exit 1
	end
systemname = ''
times. = 0
seen. = 0
systems. = ''
ntimes = 0
do while ~eof('jrclog')
	logline = readln('jrclog')
	parse var logline junk 'Connected to: ' sysname
	if sysname ~= '' then
		do
		parse var logline connectdate connecttime .
		systemname = sysname
		end
	else
		do
		parse var logline junk 'Disconnect' ed
		if ed ~= '' then
			if systemname ~= '' then
				do
				parse var logline disconnectdate disconnecttime .
				/* compute time connected, add to store */
				addtime = timediff(connecttime,disconnecttime)
				times.systemname = times.systemname + addtime
				if ~seen.systemname then
					do
					seen.systemname = 1
					ntimes = ntimes + 1
					systems.ntimes = systemname
					end
				systemname = ''
				end
		end
	end
close('jrclog')
do i = 1 to ntimes
	sys = systems.i
	conntime = times.sys
	hours = conntime % 3600
	minutes = ( conntime - hours * 3600 ) % 60
	seconds = conntime // 60
	say left(sys,30) right(hours,2) 'hours' right(minutes,2) 'minutes' right(seconds,2) 'seconds'
end
exit 0

/*
 *	Return the difference in seconds between two time strings of the format
 *
 *		hh:mm:ss    where hh is from 00 to 23.
 */

timediff: procedure
	arg t0,t1
	parse var t0 h0 ':' m0 ':' s0
	parse var t1 h1 ':' m1 ':' s1
	hd = h1 - h0
	md = m1 - m0
	sd = s1 - s0
	if hd < 0 then hd = hd + 24		/* wrapped around midnight */
	diff = hd * 3600 + md * 60 + sd
	return diff
